/*
 * protocol initialization calls
 *
 * Warning: this file is generated from graph.comp and is overwritten
 * every time 'make compose' is run
 */

#include "upi.h"
#include "x_util.h"
#include "compose.h"
#include "protocols.h"


XObj		protl_tab[15+1];
static XObj	argv[15];


void
build_pgraph_dev()
{
}


void
build_pgraph()
{

  /*
   *  building protocol ETH
   */
  protl_tab[0] = xCreateProtl(eth_init, "eth", "",
#ifdef XK_DEBUG
			&traceethp,
#else
			0,
#endif
				0, argv);
  if ( protl_tab[0] == ERR_XOBJ ) {
      Kabort("Could not create eth protocol");
  }


  /*
   *  building protocol ARP
   */
  argv[0] = protl_tab[0];
  protl_tab[1] = xCreateProtl(arp_init, "arp", "",
#ifdef XK_DEBUG
			&tracearpp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[1] == ERR_XOBJ ) {
      Kabort("Could not create arp protocol");
  }


  /*
   *  building protocol IP
   */
  argv[0] = protl_tab[0];
  argv[1] = protl_tab[1];
  protl_tab[2] = xCreateProtl(ip_init, "ip", "",
#ifdef XK_DEBUG
			&traceipp,
#else
			0,
#endif
				2, argv);
  if ( protl_tab[2] == ERR_XOBJ ) {
      Kabort("Could not create ip protocol");
  }


  /*
   *  building protocol ICMP
   */
  argv[0] = protl_tab[2];
  protl_tab[3] = xCreateProtl(icmp_init, "icmp", "",
#ifdef XK_DEBUG
			&traceicmpp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[3] == ERR_XOBJ ) {
      Kabort("Could not create icmp protocol");
  }


  /*
   *  building protocol BLAST
   */
  argv[0] = protl_tab[2];
  protl_tab[5] = xCreateProtl(blast_init, "blast", "ip",
#ifdef XK_DEBUG
			&traceblastp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[5] == ERR_XOBJ ) {
      Kabort("Could not create blast protocol");
  }


  /*
   *  building protocol VSIZE
   */
  argv[0] = protl_tab[2];
  argv[1] = protl_tab[5];
  protl_tab[7] = xCreateProtl(vsize_init, "vsize", "ip",
#ifdef XK_DEBUG
			&tracevsizep,
#else
			0,
#endif
				2, argv);
  if ( protl_tab[7] == ERR_XOBJ ) {
      Kabort("Could not create vsize protocol");
  }


  /*
   *  building protocol BLAST
   */
  argv[0] = protl_tab[0];
  protl_tab[6] = xCreateProtl(blast_init, "blast", "eth",
#ifdef XK_DEBUG
			&traceblastp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[6] == ERR_XOBJ ) {
      Kabort("Could not create blast protocol");
  }


  /*
   *  building protocol VSIZE
   */
  argv[0] = protl_tab[0];
  argv[1] = protl_tab[6];
  protl_tab[8] = xCreateProtl(vsize_init, "vsize", "eth",
#ifdef XK_DEBUG
			&tracevsizep,
#else
			0,
#endif
				2, argv);
  if ( protl_tab[8] == ERR_XOBJ ) {
      Kabort("Could not create vsize protocol");
  }


  /*
   *  building protocol VADDR
   */
  argv[0] = protl_tab[7];
  argv[1] = protl_tab[8];
  argv[2] = protl_tab[1];
  protl_tab[4] = xCreateProtl(vaddr_init, "vaddr", "",
#ifdef XK_DEBUG
			&tracevaddrp,
#else
			0,
#endif
				3, argv);
  if ( protl_tab[4] == ERR_XOBJ ) {
      Kabort("Could not create vaddr protocol");
  }


  /*
   *  building protocol UDP
   */
  argv[0] = protl_tab[2];
  protl_tab[9] = xCreateProtl(udp_init, "udp", "",
#ifdef XK_DEBUG
			&traceudpp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[9] == ERR_XOBJ ) {
      Kabort("Could not create udp protocol");
  }


  /*
   *  building protocol SUNRPC
   */
  argv[0] = protl_tab[9];
  protl_tab[10] = xCreateProtl(sunrpc_init, "sunrpc", "",
#ifdef XK_DEBUG
			&tracesunrpcp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[10] == ERR_XOBJ ) {
      Kabort("Could not create sunrpc protocol");
  }


  /*
   *  building protocol TCP
   */
  argv[0] = protl_tab[2];
  protl_tab[11] = xCreateProtl(tcp_init, "tcp", "",
#ifdef XK_DEBUG
			&tracetcpp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[11] == ERR_XOBJ ) {
      Kabort("Could not create tcp protocol");
  }


  /*
   *  building protocol CHAN
   */
  argv[0] = protl_tab[4];
  protl_tab[12] = xCreateProtl(chan_init, "chan", "",
#ifdef XK_DEBUG
			&tracechanp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[12] == ERR_XOBJ ) {
      Kabort("Could not create chan protocol");
  }


  /*
   *  building protocol VCHAN
   */
  argv[0] = protl_tab[12];
  protl_tab[13] = xCreateProtl(vchan_init, "vchan", "",
#ifdef XK_DEBUG
			&tracevchanp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[13] == ERR_XOBJ ) {
      Kabort("Could not create vchan protocol");
  }


  /*
   *  building protocol SELECT
   */
  argv[0] = protl_tab[13];
  protl_tab[14] = xCreateProtl(select_init, "select", "",
#ifdef XK_DEBUG
			&traceselectp,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[14] == ERR_XOBJ ) {
      Kabort("Could not create select protocol");
  }

}
