/*
 * $RCSfile: ethtap.h,v $
 * 
 * 
 *
 * Copyright (c) 1997  Arizona Board of Regents
 *
 * $Log: ethtap.h,v $
 * Revision 1.1  1997/04/23 19:15:38  mjk
 * Initial revision
 *
 */

#ifndef __ethtap_h
#define __ethtap_h

#include <linux/config.h>
#include <linux/major.h>


/* This should be moved to <linux/proc_fs.h> -- check to make sure
 * number is safe.
 */

#ifndef PROC_NET_ETHTAP
# define PROC_NET_ETHTAP	PROC_NET_LAST + 1
#endif


/* This should be moved to <linux/major.h> -- check to make sure
 * numbera are safe.
 */

#ifndef ETHTAP_HIGH_MAJOR
# define ETHTAP_HIGH_MAJOR	50
#endif

#ifndef ETHTAP_LOW_MAJOR
# define ETHTAP_LOW_MAJOR	51
#endif

#ifdef CONFIG_ETHTAP_DEBUG
# define TAPDEBUG(fmt, args...)	printk(fmt , ## args)
#else
# define TAPDEBUG(fmt, args...)
#endif


	/* ioctl() commands 						*/
#define ETHTAPSETMODE		0x33340001 /* xkout, xkin		*/
#define ETHTAPGETMODE		0x33340002 /* xkout, xkin		*/
#define ETHTAPZEROCOUNTS	0x33340003 /* xkout, xkin		*/

	/* ioctl() args 						*/
#define ETHTAP_CLOSED_MODE	0x00000000 /* for internal use only	*/
#define ETHTAP_PASSIVE_MODE	0x00000001 /* XK[SET|GET]MODE		*/
#define ETHTAP_ACTIVE_MODE	0x00000002 /* XK[SET|GET]MODE 		*/


#endif
