/*
 * cookie_photuris_i.h
 *
 * x-kernel v3.2
 *
 *
 *
 */

#include "cookie_photuris.h"

#define HOSTTYPE IPhost

#define RANDOM_SIZE 4

typedef struct {
    Map		cookieMap;
    XObj	hlp;
    XObj	hlpType;
    char	random[RANDOM_SIZE];
} PState;

#define COOKIE_MAP_SIZE 32

/* hash size in bytes */
#define HASH_SIZE_BYTES 16

#define INITIATOR_COOKIE_MISSING	1
#define RESPONDER_COOKIE_MISSING	2
#define OPERATIONAL			3

typedef unsigned char cookie_t[HASH_SIZE_BYTES];

typedef struct {
  cookie_t	*Initiator_cookie, *Responder_cookie;
  HOSTTYPE	remhost;
  Msg		msg;
  int		waiting;
  int  		state;
} SState;

typedef struct {
  cookie_t	Initiator_cookie;
  cookie_t 	Responder_cookie;
  XObj		lls;
} MapKey;



